Subject: Re: [lojban] Re: Grammatical Examples in the CLL (was Re: Re: Ungrammatical examples in CLL)

From: Robert LeChevalier <[email-masked]>
Date: Fri, 07 Feb 2003 23:45:28 -0500

At 11:03 AM 2/7/03 -0800, Robin Lee Powell wrote:
> > So you can't put a prenex in there after a .ifoo connective.
> >
> > Yes this sucks.
> >
> > The older grammar (which the official parser uses) supports this. I
> > have no idea why it was removed.
>
>What did the older rules look like?

Here is the old grammar and Techfix 45 (which incidentally is the format 
I'm hoping that people will use to propose changes to the baseline).

>CHANGE 45
>CURRENT LANGUAGE:
>Grammatically, I and ijek are treated identically, although in the
>semantics, I constitutes a stronger boundary.
>Prenexes can be attached only to sentences or to TUhE...TUhU groups, although
>logically a prenex can persist across several sentences connected by
>ijeks.
>PROPOSED CHANGE:
>Treat I as a higher-priority break than ijek (which is higher than
>I+BO or ijek+BO; no distinction is made between I+BO and ijek+BO).
>Shift all the sentence fragments (the forms of utterance_20 which are not
>sentence_40) to a higher level; they can only be connected by I, not by any
>lower-level form.
>Attach prenexes to the new level "statement_11"; statements contain ijeks
>and I+BOs, but not bare Is.
>RATIONALE:
>1) It has always been a rule that I and ijek have different semantic
>implications: I is a pure separator, whereas ijek connects as well as
>separating. In particular, logical variables persist across ijek
>boundaries always, but (by default) not across I boundaries. This change
>makes the grammar reflect the semantics.
>2) Logically connecting sentence fragments never did make very much sense,
>but was allowed because of the lack of distinction between I and ijek.

>paragraphs_4 : utt_string_A_10
> | utt_string_A_10 para_mark_410 paragraphs_4
> ;
>
>utt_string_A_10 : utt_string_B_11
> | utt_string_A_10 I_819 utt_string_B_11
> | utt_string_A_10 I_819 POhO_gap_455
> /* this last fixes an erroneous start to a sentence,
> and permits incomplete JOIK_JEK after I, as well
> in answer to questions on those connectives */
> ;
>
>utt_string_B_11 : utt_string_C_12
> | utt_string_C_12 I_BO_811 utt_string_B_11
> | utt_string_C_12 I_BO_811 POhO_gap_455
> /* this last fixes an erroneous start to a sentence,
> and permits incomplete JOIK_JEK after I, as well
> in answer to questions on those connectives */
> ;
>
>utt_string_C_12 : utterance_20
> | TUhE_610 paragraphs_4 TUhU_gap_454
> | header_terms_30 TUhE_610 paragraphs_4 
> TUhU_gap_454
> | PU_mod_491 TUhE_610 paragraphs_4 TUhU_gap_454
> ;

I_819 included the following indirectly:
>I_root_956 : I_545
> | I_545 JOIK_JEK_957
> ;
>
>
>JOIK_JEK_957 : JOIK_806
> | JEK_805
> ;
> /* no freemod in this version; cf. JOIK_JEK_422 */
> /* this reference to a version of JOIK and JEK
> which already have the lexer_lexemes attached
> prevents shift/reduce errors. The problem is
> resolved in a hard-coded parser implementation
> which builds lexer_K, before lexer_S, before
> lexer_E and lexer_F. */

> > All that needs to be done to fix it is to make the part after the
> > connective of the statement1 and statement2 things use a "statement"
> > rule instead of a "statement2" rule, and to decide what kind of scope
> > the outer prenex has.
>
>That last part might take some work.

Especially since it effectively undoes a grammar change. It seems clear 
that Cowan intended it this way, and he apparently convinced me and others 
at the time.

lojbab

-- 
lojbab [email-masked]
Bob LeChevalier, President, The Logical Language Group, Inc.
2904 Beau Lane, Fairfax VA 22031-1303 USA 703-385-0273
Artificial language Loglan/Lojban: http://www.lojban.org